# all files / ol/tilegrid/ wmtstilegrid.js

95.56% Statements 43/45
66.67% Branches 4/6
83.33% Functions 5/6
95.56% Lines 43/45

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    1351×

    1×
    1×
    1×

    1×

    10×

    10×

    10×

    1×

    1×
    2×

    2×

    1×

    1×

    5×

    5×

    5×

    5×

    5×

    5×
    5×
    5×
    5×
    5×
    5×
    5×

    5×
    5×

    5×

    5×

    5×
    317×

    5×
    94×
    94×
    94×
    94×
    94×

    94×

    94×
    94×

    94×

    5×

     goog.provide('ol.tilegrid.WMTS');

    goog.require('goog.asserts');
    goog.require('ol.proj');
    goog.require('ol.tilegrid.TileGrid');

    /**
     * @classdesc
     * Set the grid pattern for sources accessing WMTS tiled-image servers.
     *
     * @constructor
     * @extends {ol.tilegrid.TileGrid}
     * @param {olx.tilegrid.WMTSOptions} options WMTS options.
     * @struct
     * @api
     */
    ol.tilegrid.WMTS = function(options) {

      goog.asserts.assert(
          options.resolutions.length == options.matrixIds.length,
          'options resolutions and matrixIds must have equal length (%s == %s)',
          options.resolutions.length, options.matrixIds.length);

      /**
       * @private
       * @type {!Array.<string>}
       */
      this.matrixIds_ = options.matrixIds;
      // FIXME: should the matrixIds become optionnal?

      goog.base(this, {
        extent: options.extent,
        origin: options.origin,
        origins: options.origins,
        resolutions: options.resolutions,
        tileSize: options.tileSize,
        tileSizes: options.tileSizes,
        sizes: options.sizes
      });

    };
    goog.inherits(ol.tilegrid.WMTS, ol.tilegrid.TileGrid);

    /**
     * @param {number} z Z.
     * @return {string} MatrixId..
     */
    ol.tilegrid.WMTS.prototype.getMatrixId = function(z) {
      goog.asserts.assert(0 <= z && z < this.matrixIds_.length,
          'attempted to retrive matrixId for illegal z (%s)', z);
      return this.matrixIds_[z];
    };

    /**
     * Get the list of matrix identifiers.
     * @return {Array.<string>} MatrixIds.
     * @api
     */
    ol.tilegrid.WMTS.prototype.getMatrixIds = function() {
      return this.matrixIds_;
    };

    /**
     * Create a tile grid from a WMTS capabilities matrix set.
     * @param {Object} matrixSet An object representing a matrixSet in the
     *     capabilities document.
     * @param {ol.Extent=} opt_extent An optional extent to restrict the tile
     *     ranges the server provides.
     * @return {ol.tilegrid.WMTS} WMTS tileGrid instance.
     * @api
     */
    ol.tilegrid.WMTS.createFromCapabilitiesMatrixSet = function(matrixSet, opt_extent) {

      /** @type {!Array.<number>} */
      var resolutions = [];
      /** @type {!Array.<string>} */
      var matrixIds = [];
      /** @type {!Array.<ol.Coordinate>} */
      var origins = [];
      /** @type {!Array.<ol.Size>} */
      var tileSizes = [];
      /** @type {!Array.<ol.Size>} */
      var sizes = [];

      var supportedCRSPropName = 'SupportedCRS';
      var matrixIdsPropName = 'TileMatrix';
      var identifierPropName = 'Identifier';
      var scaleDenominatorPropName = 'ScaleDenominator';
      var topLeftCornerPropName = 'TopLeftCorner';
      var tileWidthPropName = 'TileWidth';
      var tileHeightPropName = 'TileHeight';

      var projection;
      projection = ol.proj.get(matrixSet[supportedCRSPropName].replace(
          /urn:ogc:def:crs:(\w+):(.*:)?(\w+)$/, '$1:$3'));
      var metersPerUnit = projection.getMetersPerUnit();
      // swap origin x and y coordinates if axis orientation is lat/long
      var switchOriginXY = projection.getAxisOrientation().substr(0, 2) == 'ne';

      matrixSet[matrixIdsPropName].sort(function(a, b) {
        return b[scaleDenominatorPropName] - a[scaleDenominatorPropName];
      });

      matrixSet[matrixIdsPropName].forEach(function(elt, index, array) {
        matrixIds.push(elt[identifierPropName]);
        var resolution = elt[scaleDenominatorPropName] * 0.28E-3 / metersPerUnit;
        var tileWidth = elt[tileWidthPropName];
        var tileHeight = elt[tileHeightPropName];
        Iif (switchOriginXY) {
          origins.push([elt[topLeftCornerPropName][1],
            elt[topLeftCornerPropName][0]]);
        } else {
          origins.push(elt[topLeftCornerPropName]);
        }
        resolutions.push(resolution);
        tileSizes.push(tileWidth == tileHeight ?
            tileWidth : [tileWidth, tileHeight]);
        // top-left origin, so height is negative
        sizes.push([elt['MatrixWidth'], -elt['MatrixHeight']]);
      });

      return new ol.tilegrid.WMTS({
        extent: opt_extent,
        origins: origins,
        resolutions: resolutions,
        matrixIds: matrixIds,
        tileSizes: tileSizes,
        sizes: sizes
      });
    };